//lmdm.cs

datablock AudioProfile(lmdmExplosionSound)
{
   filename    = "./Dynamiteboom.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(lmdmFuseSound)
{
   filename    = "./Dynamitefuse.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

//lmdm trail
datablock ParticleData(lmdmTrailParticle)
{
	dragCoefficient		= 0.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= -0.5;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 500;
	lifetimeVarianceMS	= 300;
	spinSpeed		= 0;
	spinRandomMin		= -30.0;
	spinRandomMax		= 30.0;
	useInvAlpha		= false;

	textureName		= "base/data/particles/cloud";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "1 1 0.3 0.0";
	colors[1]	= "1 1 0.3 1.0";
	colors[2]	= "0.6 0 0 0.0";
	sizes[0]	= 0.0;
	sizes[1]	= 0.1;
	sizes[2]	= 0.009;
	times[0]	= 0.0;
	times[1]	= 0.2;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(lmdmTrailEmitter)
{
   ejectionPeriodMS = 14;
   periodVarianceMS = 4;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0.10;

   thetaMin         = 0.0;
   thetaMax         = 180;  

   phiReferenceVel  = 0;
   phiVariance      = 360;

   particles = lmdmTrailParticle;

   useEmitterColors = true;
   uiName = "LEGO Dynamite Trail";
};


//effects
datablock ParticleData(lmdmExplosionParticle)
{
	dragCoefficient		= 1.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= -0.2;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 2000;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 2.0;
	spinRandomMin		= -30.0;
	spinRandomMax		= 30.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
	colors[0]	= "1.0 0.8 0.3 1.0";
	colors[1]	= "0.0 0.0 0.0 0.3";
	sizes[0]	= 15.0;
	sizes[1]	= 18.0;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(lmdmExplosionEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 1;
   lifeTimeMS	   = 150;
   ejectionVelocity = 20;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 20;
   thetaMax         = 30;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "lmdmExplosionParticle";
};

datablock ParticleData(lmdmExplosionParticle2)
{
	dragCoefficient		= 0.1;
	windCoefficient		= 0.0;
	gravityCoefficient	= -0.4;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 1000;
	lifetimeVarianceMS	= 50;
	spinSpeed		= 10.0;
	spinRandomMin		= -90.0;
	spinRandomMax		= 90.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
	colors[0]	= "1.0 0.8 0.3 1.0";
	colors[1]	= "0.0 0.0 0.0 0.3";
	sizes[0]	= 8.0;
	sizes[1]	= 10.0;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(lmdmExplosionEmitter2)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 0;
   lifetimeMS       = 150;
   ejectionVelocity = 20;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 85;
   thetaMax         = 90;
   phiReferenceVel  = 5;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "lmdmExplosionParticle2";
};

datablock ExplosionData(lmdmExplosion)
{
   //explosionShape = "Add-Ons/Weapon_Rocket Launcher/explosionSphere1.dts";
   lifeTimeMS = 150;

   soundProfile = lmdmExplosionSound;

   emitter[0] = lmdmExplosionEmitter;
   emitter[1] = lmdmExplosionEmitter2;
   //particleDensity = 10;
   //particleRadius = 1.0;

   faceViewer     = false;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.5 1.5 1.5";
   camShakeDuration = 0.8;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 10;
   lightEndRadius = 15;
   lightStartColor = "1.0 0.8 0.5";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 20;
   impulseForce = 5000;

   //radius damage
   radiusDamage        = 300;
   damageRadius        = 13;
};

//projectile
AddDamageType("lmdmDirect",   '<bitmap:add-ons/Weapon_Legopowerminers/CI_lmdm> %1',       '%2 <bitmap:add-ons/Weapon_Legopowerminers/CI_lmdm> %1',1,1);
AddDamageType("lmdmRadius",   '<bitmap:add-ons/Weapon_Legopowerminers/CI_lmdm> %1',       '%2 <bitmap:add-ons/Weapon_Legopowerminers/CI_lmdm> %1',1,0);
datablock ProjectileData(lmdmProjectile)
{
   projectileShapeName = "./lmdmp.dts";
   directDamage        = 5;
   directDamageType  = $DamageType::lmdmDirect;
   radiusDamageType  = $DamageType::lmdmRadius;
   impactImpulse	   = 200;
   verticalImpulse	   = 200;
   explosion           = lmdmExplosion;
   particleEmitter     = lmdmTrailEmitter;

   brickExplosionRadius = 15;
   brickExplosionImpact = false; //destroy a brick if we hit it directly?
   brickExplosionForce  = 20;
   brickExplosionMaxVolume = 360;
   brickExplosionMaxVolumeFloating = 360;

   sound = lmdmFuseSound;

   muzzleVelocity      = 30;
   velInheritFactor    = 0;
  explodeOnDeath = true;

   armingDelay         = 2500;
   lifetime            = 2500;
   fadeDelay           = 3000;
   bounceElasticity    = 0.2;
   bounceFriction      = 0.1;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = true;
   lightRadius = 1;
   lightColor  = "1.0 0.8 0.5";

   uiName = "LEGO Dynamite";
};


//////////
// item //
//////////
datablock ItemData(lmdmItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./lmdm.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "LEGO Dynamite";
	iconName = "./icon_lmdm";
	doColorShift = false;
	colorShiftColor = "0.400 0.196 0 1.000";

	 // Dynamic properties defined by the scripts
	image = lmdmImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(lmdmImage)
{
   // Basic Item properties
   shapeFile = "./lmdm.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = lmdmItem;
   ammo = " ";
   projectile = lmdmProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.400 0.196 0 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.3;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;
	stateEmitter[1]					= lmdmTrailEmitter;
	stateEmitterTime[1]				= 0.5;
	stateEmitterNode[1]				= muzzlePoint;
	stateSound[1]					= lmdmFuseSound;
	stateTransitionOnTimeout[1]	= "Ready";
	stateTimeoutValue[1]            = 0.5;
	
	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 0.7;
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateScript[2]                  = "onCharge";
	stateAllowImageChange[2]        = false;
	stateEmitter[2]					= lmdmTrailEmitter;
	stateEmitterTime[2]				= 0.7;
	stateEmitterNode[2]				=  muzzlePoint;
	stateSound[2]					= lmdmFuseSound;
	
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 0.3;
	stateWaitForTimeout[3]		= true;
	stateScript[3]			= "onAbortCharge";
	stateAllowImageChange[3]	= false;
	stateEmitter[3]					= lmdmTrailEmitter;
	stateEmitterTime[3]				= 0.3;
	stateEmitterNode[3]				=  muzzlePoint;
	stateSound[3]					= lmdmFuseSound;

	stateName[4]			= "Armed";
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateAllowImageChange[4]	= false;
	stateEmitter[4]					= lmdmTrailEmitter;
	stateEmitterTime[4]				= 0.5;
	stateEmitterNode[4]				=  muzzlePoint;
	stateSound[4]					= lmdmFuseSound;
	stateTransitionOnTimeout[4]	= "Armed";
	stateTimeoutValue[4]            = 0.5;

	stateName[5]			= "Fire";
	stateTransitionOnTimeout[5]	= "Done";
	stateTimeoutValue[5]		= 0.5;
	stateFire[5]			= true;
	stateSequence[5]		= "fire";
	stateScript[5]			= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;

	stateName[6]					= "Done";
	stateScript[6]					= "onDone";

};

package lmdmPackage
{
	function Armor::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
	{
		if(%col.dataBlock $= "lmdmItem" && %col.canPickup)
		{
			for(%i=0;%i<%this.maxTools;%i++)
			{
				%item = %obj.tool[%i];
				if(%item $= 0 || %item $= "")
				{
					%freeSlot = 1;
					break;
				}
			}

			if(%freeSlot)
			{
				%obj.pickup(%col);
				return;
			}
		}
		Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
	}
};
activatePackage(lmdmPackage);

function lmdmImage::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
	%obj.lastHESlot = %obj.currTool;
}

function lmdmImage::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function lmdmImage::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, spearThrow);
	Parent::OnFire(%this, %obj, %slot);

	%currSlot = %obj.lastHESlot;
	%obj.tool[%currSlot] = 0;
	%obj.weaponCount--;
	messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
	serverCmdUnUseTool(%obj.client);
}

function lmdmImage::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}

datablock DecalData(lmdmIcon)
{
   textureName = "Add-Ons/Weapon_Legopowerminers/icon_lmdm";
};